VERSION 5.00
Begin VB.UserControl testcontrol 
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   420
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2115
   ScaleHeight     =   28
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   141
   Begin VB.Label Label1 
      Caption         =   "ADO ActiveX Control"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1575
   End
End
Attribute VB_Name = "testcontrol"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Dim WithEvents oconn As ADODB.Connection
Attribute oconn.VB_VarHelpID = -1
Dim WithEvents ors As ADODB.recordset
Attribute ors.VB_VarHelpID = -1
'Event Declarations:
Event ConnectComplete(ByVal pError As ADODB.Error, adStatus As ADODB.EventStatusEnum, ByVal pConnection As ADODB.Connection)
Event Disconnect(adStatus As ADODB.EventStatusEnum, ByVal pConnection As ADODB.Connection)
Event MoveComplete(ByVal adReason As ADODB.EventReasonEnum, ByVal pError As ADODB.Error, adStatus As ADODB.EventStatusEnum, ByVal pRecordset As ADODB.recordset)
Event RecordChangeComplete(ByVal adReason As ADODB.EventReasonEnum, ByVal cRecords As Long, ByVal pError As ADODB.Error, adStatus As ADODB.EventStatusEnum, ByVal pRecordset As ADODB.recordset)
Event EndOfRecordset(fMoreData As Boolean, adStatus As ADODB.EventStatusEnum, ByVal pRecordset As ADODB.recordset)
Event FetchComplete(ByVal pError As ADODB.Error, adStatus As ADODB.EventStatusEnum, ByVal pRecordset As ADODB.recordset)
Event FetchProgress(ByVal Progress As Long, ByVal MaxProgress As Long, adStatus As ADODB.EventStatusEnum, ByVal pRecordset As ADODB.recordset)
Event FieldChangeComplete(ByVal cFields As Long, ByVal Fields As Variant, ByVal pError As ADODB.Error, adStatus As ADODB.EventStatusEnum, ByVal pRecordset As ADODB.recordset)
Event RecordsetChangeComplete(ByVal adReason As ADODB.EventReasonEnum, ByVal pError As ADODB.Error, adStatus As ADODB.EventStatusEnum, ByVal pRecordset As ADODB.recordset)
Event WillChangeField(ByVal cFields As Long, ByVal Fields As Variant, adStatus As ADODB.EventStatusEnum, ByVal pRecordset As ADODB.recordset)
Event WillChangeRecord(ByVal adReason As ADODB.EventReasonEnum, ByVal cRecords As Long, adStatus As ADODB.EventStatusEnum, ByVal pRecordset As ADODB.recordset)
Event WillChangeRecordset(ByVal adReason As ADODB.EventReasonEnum, adStatus As ADODB.EventStatusEnum, ByVal pRecordset As ADODB.recordset)
Event WillMove(ByVal adReason As ADODB.EventReasonEnum, adStatus As ADODB.EventStatusEnum, ByVal pRecordset As ADODB.recordset)

'Default Property Values:
Const m_def_RecordSetSource = 0
Const m_def_provider = 0
Const m_def_connectionstring = 0
'Property Variables:
Dim m_RecordSetSource As Variant
Dim m_provider As Variant
Dim m_connectionstring As Variant
Private Sub oconn_ConnectComplete(ByVal pError As ADODB.Error, adStatus As ADODB.EventStatusEnum, ByVal pConnection As ADODB.Connection)
   RaiseEvent ConnectComplete(pError, adStatus, pConnection)
End Sub
Private Sub oconn_Disconnect(adStatus As ADODB.EventStatusEnum, ByVal pConnection As ADODB.Connection)
    RaiseEvent Disconnect(adStatus, pConnection)
End Sub
Private Sub ors_EndOfRecordset(fMoreData As Boolean, adStatus As ADODB.EventStatusEnum, ByVal pRecordset As ADODB.recordset)
   RaiseEvent EndOfRecordset(fMoreData, adStatus, pRecordset)
End Sub
Private Sub ors_FetchComplete(ByVal pError As ADODB.Error, adStatus As ADODB.EventStatusEnum, ByVal pRecordset As ADODB.recordset)
   RaiseEvent FetchComplete(pError, adStatus, pRecordset)
End Sub
Private Sub ors_FetchProgress(ByVal Progress As Long, ByVal MaxProgress As Long, adStatus As ADODB.EventStatusEnum, ByVal pRecordset As ADODB.recordset)
   RaiseEvent FetchProgress(Progress, MaxProgress, adStatus, pRecordset)
End Sub
Private Sub ors_FieldChangeComplete(ByVal cFields As Long, ByVal Fields As Variant, ByVal pError As ADODB.Error, adStatus As ADODB.EventStatusEnum, ByVal pRecordset As ADODB.recordset)
   RaiseEvent FieldChangeComplete(cFields, Fields, pError, adStatus, pRecordset)
End Sub
Private Sub ors_MoveComplete(ByVal adReason As ADODB.EventReasonEnum, ByVal pError As ADODB.Error, adStatus As ADODB.EventStatusEnum, ByVal pRecordset As ADODB.recordset)
   RaiseEvent MoveComplete(adReason, pError, adStatusCancel, pRecordset)
End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=14,0,0,0
Public Property Get provider() As Variant
    provider = m_provider
End Property
Public Property Let provider(ByVal New_provider As Variant)
    m_provider = New_provider
    PropertyChanged "provider"
End Property
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=14,0,0,0
Public Property Get connectionstring() As Variant
    connectionstring = m_connectionstring
End Property
Public Property Let connectionstring(ByVal New_connectionstring As Variant)
    m_connectionstring = New_connectionstring
    PropertyChanged "connectionstring"
End Property
Private Sub ors_RecordChangeComplete(ByVal adReason As ADODB.EventReasonEnum, ByVal cRecords As Long, ByVal pError As ADODB.Error, adStatus As ADODB.EventStatusEnum, ByVal pRecordset As ADODB.recordset)
   RaiseEvent RecordChangeComplete(adReason, cRecords, pError, adStatus, pRecordset)
End Sub
Private Sub ors_RecordsetChangeComplete(ByVal adReason As ADODB.EventReasonEnum, ByVal pError As ADODB.Error, adStatus As ADODB.EventStatusEnum, ByVal pRecordset As ADODB.recordset)
   RaiseEvent RecordsetChangeComplete(adReason, pError, adStatus, pRecordset)
End Sub
Private Sub ors_WillChangeField(ByVal cFields As Long, ByVal Fields As Variant, adStatus As ADODB.EventStatusEnum, ByVal pRecordset As ADODB.recordset)
   RaiseEvent WillChangeField(cFields, Fields, adStatus, pRecordset)
End Sub
Private Sub ors_WillChangeRecord(ByVal adReason As ADODB.EventReasonEnum, ByVal cRecords As Long, adStatus As ADODB.EventStatusEnum, ByVal pRecordset As ADODB.recordset)
   RaiseEvent WillChangeRecord(adReason, cRecords, adStatus, pRecordset)
End Sub
Private Sub ors_WillChangeRecordset(ByVal adReason As ADODB.EventReasonEnum, adStatus As ADODB.EventStatusEnum, ByVal pRecordset As ADODB.recordset)
   RaiseEvent WillChangeRecordset(adReason, adStatus, pRecordset)
End Sub
Private Sub ors_WillMove(ByVal adReason As ADODB.EventReasonEnum, adStatus As ADODB.EventStatusEnum, ByVal pRecordset As ADODB.recordset)
   RaiseEvent WillMove(adReason, adStatus, pRecordset)
End Sub
'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    m_provider = m_def_provider
    m_connectionstring = m_def_connectionstring
    m_RecordSetSource = m_def_RecordSetSource
    m_adoconnection = m_def_adoconnection
    m_adorecordset = m_def_adorecordset
End Sub
'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    m_provider = PropBag.ReadProperty("provider", m_def_provider)
    m_connectionstring = PropBag.ReadProperty("connectionstring", m_def_connectionstring)
    m_RecordSetSource = PropBag.ReadProperty("RecordSetSource", m_def_RecordSetSource)
    m_adoconnection = PropBag.ReadProperty("adoconnection", m_def_adoconnection)
    m_adorecordset = PropBag.ReadProperty("adorecordset", m_def_adorecordset)
End Sub
'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("provider", m_provider, m_def_provider)
    Call PropBag.WriteProperty("connectionstring", m_connectionstring, m_def_connectionstring)
    Call PropBag.WriteProperty("RecordSetSource", m_RecordSetSource, m_def_RecordSetSource)
    Call PropBag.WriteProperty("adoconnection", m_adoconnection, m_def_adoconnection)
    Call PropBag.WriteProperty("adorecordset", m_adorecordset, m_def_adorecordset)
End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=14
Public Sub CreateConnection()
   Set oconn = New ADODB.Connection
   With oconn
      .provider = Me.provider
      .connectionstring = Me.connectionstring
      .Open
   End With
End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=14
Public Sub CreateRecordSet()
   Set ors = New ADODB.recordset
   ors.Open Me.RecordSetSource, oconn, adOpenStatic, adLockBatchOptimistic
End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=14,0,0,0
Public Property Get RecordSetSource() As Variant
    RecordSetSource = m_RecordSetSource
End Property
Public Property Let RecordSetSource(ByVal New_RecordSetSource As Variant)
    m_RecordSetSource = New_RecordSetSource
    PropertyChanged "RecordSetSource"
End Property
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=14
Public Sub connectionclose()
   oconn.Close
End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=14
Public Sub recordsetclose()
   ors.Close
End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=14,0,0,0
Public Property Get adoconnection() As ADODB.Connection
    Set adoconnection = oconn
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=14,0,0,0
Public Property Get adorecordset() As ADODB.recordset
    Set adorecordset = ors
End Property
